          ::--::--:: SQL: Structured Query Language ::--::--::
 SQL (Structured Query Language), veritabanlarna erimek ve ynetmek iin kullanlan yapsal
sorgulama dilidir. SQL, verilerin depolanmas, gncellenmesi, silinmesi ve sorgulanmas gibi birok 
ilemi gerekletirmek iin kullanlabilir.

SQL, ilikisel veritabanlar iin zel olarak tasarlanmtr ve verilerin dzenli bir ekilde depolanmasna, 
organize edilmesine ve aranmasna yardmc olur. SQL, nceden tanmlanm bir dizi komut 
(SELECT, INSERT, UPDATE, DELETE vb.) kullanarak veritabanlarna eriir.

SQL, hem byk lekli iletmelerin hem de kk iletmelerin kullanabilecei bir teknolojidir. 
Birok programlama dili ve veritaban sistemi, SQLi desteklemektedir. SQL, kullanm kolay, renmesi 
kolay ve ok ynl bir programlama dilidir ve birok veritaban ynetim sisteminin temelini oluturur.


         ::--::--:: T-SQL ::--::--::
T-SQL (Transact-SQL), Microsoft SQL Server veritaban ynetim sistemi tarafndan kullanlan 
bir sorgu dili ve programlama dili olarak hizmet verir. T-SQL, SQL standartlarna ek olarak, 
programlama zellikleri salar.

T-SQL, birok zellik sunar, rnein:

* Veritaban ilemlerini gerekletirmek iin SQL sorgular kullanr
* Prosedrler, fonksiyonlar, tetikleyiciler, saklama prosedrleri ve dier programlama nesneleri ile 
yaplandrlm programlama salar
* Deikenler, koullu ifadeler, dngler ve dier kontrol yaplar salar
* Dizinleme, tablo ve dizeler gibi bir dizi veri tr salar
* T-SQL sorgular, veritaban ynetim sistemi tarafndan kullanlan zel bir yntemle optimize edilebilir, 
bu nedenle yksek performans elde edilir.
* T-SQL, Microsoft SQL Server veritaban ynetim sistemi ile birlikte kullanldnda, 
veritaban ilemlerini gerekletirmek iin gl bir aratr. Ayn zamanda, T-SQL ile yazlan uygulamalar, 
yksek performans ve gvenilirlik ile karakterizedir.

      ::--::--:: PL/SQL - Oracle tarafndan gelitirilmitir. ::--::--::
PL/SQL (Procedural Language/Structured Query Language), Oracle veritaban ynetim sistemi tarafndan 
kullanlan bir programlama dilidir. PL/SQL, Oracle veritaban ynetim sistemi ile birlikte kullanldnda, 
veritaban ilemlerinin gerekletirilmesi iin yksek dzeyde zelletirilmi bir programlama dilidir.


SQL yapsal olarak 3 gruba ayrlr:

--1- DDL (Data Defination Language / Veri Tanmlama Dili)

CREATE - aLTER - DROP

--2- DML (Data maniplation lang. / Veri leme dili)

SELECT - INSERT - UPDATE - DELETE

--3- DCL (DATA control lang. / Veri kontrol dili)

REVOKE - GRANT - DENY

-----------------------------------------

/* aklama aklama...
www.aliosmangokcan.com
bu alan aklama/yorum satrlarn gsterir */

--------------------------------------

::--::--:: SQL Server Veri Tipleri ::--::--::
bit:   0 ve 1 verisini tutmak iin... true/false  (cinsiyet, medeni durum..)
binary:  (ikilik sistem). 8000byte a kadar binary veri alabilir.

varbinary 

char(n): alfanmerik veriler iin... 

-- RNEK: ad char(15)

varchar(n): alfanmerik veriler iin... 
-- RNEK: ad varchar(15)

nvarchar(n) : alfanmerik veriler iin... 

datetime:  1753 - 9999 
smalldatetime:  1900 - 2079

image:  resim, sunu, excel dosyalarn ikili formatta saklayabildiimiz...

int:   -2milyar ksur ile +2milyar aras tam saylar tutar 

tinyint:  0 - 255 aras tam saylar tutar 

bigint:  olduka byk bir tam say aral girii iiin kullanlr. 

uniqe-identifier: 16byte uzunluunda hexadecimal (16lk say taban)

text:  ok uzun alfanmerik deerler iin... 2GB

float(n):  ondalk saylar iin....

money / smallmoney  

decimal: 38 basamaa kadar tam say iin.... virgll saylar da tutar


::--::--:: CREATE komutu ::--::--::

--Veritaban ve tablo oluturmak iin kullanlr.

create database veritaban_ad
ON
Primary (Name=dosya_ad,
filename=fiziki_dosya_ad,  -- .mdf dosya 
size=dosya_boyutu,  --default 2MB
maxsize=maksimum_dosya_boyutu,
filegrowth=dosya_art_miktar) -- default 1MB
LOG ON 
(Name=dosya_ad,
filename=fiziki_dosya,   --.ldf dosya
size=dosya_boyutu,
maxsize=maks_dos_boyutu,
filegrowth=dos_art_miktar)

--RNEK 1:
create database deneme2

--RNEK 2:
create database okul2
on
(name='okul2_dat',
filename='d:\okuldat2.mdf',
size=10,
maxsize=50MB,
filegrowth=5)
LOG ON
(name=okul2_log,
filename='d:\okullog2.ldf',
size=5MB,
maxsize=25MB,
filegrowth=5MB)

::--::--:: Create Table ::--::--::

create table tablo_adi(
stun1 veritipi1,
stun2 veritipi2,
...
stunN veritipiN) 

--RNEK 3:

use deneme2 -- tek sefere mahsus

create table personel(
pers_id int not null,
adi varchar(25),
soyadi varchar(30))


--RNEK 4:

create table ogrenci(
ogr_no int NOT NULL Primary Key,
ad_soyad varchar(25),
yas tinyint)


--RNEK 5:

create table personel2(
pers_id int,
ad_soyad varchar(50),
sehir varchar(15),
unique(pers_id))

--RNEK 6:
create table ogrenci2(
ogr_no int identity(1,3) not null,  --SEED (1)  -- increment(3)
adi varchar(25),
soyadi varchar(30),
bolum nchar(50) DEFAULT 'Bilgisayar')

--RNEK 7:
create table notlar(
ogr_no int not null,
ders_kodu varchar(25) not null,
vize tinyint,
final tinyint,
constraint birlesikPK Primary Key (ogr_no,ders_kodu)
)

--RNEK 8:
create table notlar2(
ogr_no int,
ders_kodu varchar(5),
vize int CHECK (vize>=0),
final int CHECK (final>=0))

--RNEK 9:
create table odeme(
id int,
bursiyer varchar(50),
burs int,
constraint chkburs CHECK (burs>=0 and burs<=3000))

--IN, NOT IN, LIKE Kullanm
IN ifadesi yerine OR,
NOT IN ifadesi yerine AND

LIKE
% (yzde iareti)  birden fazla karakteri ifade eder/gsterir.
_ (alt izgi)  bir tek karakteri ifade eder.
[HARF] herhangi bir karakteri (kendisini ifade eder)
[^HARF] kendisi dnda (keli parantez iinde yazlann haricinde)
[A-Z]   A ile Z arasnda bir karakteri gsterir

--RNEKLER 10:
RN:  LIKE '%T%'   --> iinde T olanlar/geenler
RN: LIKE '_G%'  --> ilk karakteri G olanlar
RN: LIKE '_ _ N'  -->  farfli son harfi N
RN: LIKE '[SA]%'  -->ilk harfi/karakteri S veya A olanlar
RN: LIKE '%[B-K]'   --> son karakteri B ile K arasnda olan
RN: LIKE '[2-8][4-7]'  --> ilk hanesi 2-8, ikinci hanesi 4-7 arasnda
RN: LIKE '[^B-N][^MOZ][A-K]'  -->   ilk karakteri B-N arasnda olmayan,
ikinci karalteri M,O veya Z olmayan, nc karalteri A-K arasnda olan

--RNEK 11:
use deneme2

create table urunler(
urun_kodu varchar(4) not null,
urun_adi varchar(25) not null,
constraint chkkod CHECK (urun_kodu IN('A089','A090','A011','A111') OR 
urun_kodu LIKE 'A9[0-9][0-9]'))

rn kodu : a089, a090, a011, a111 veya A900-A999

--RNEK 12:
create table musteri(
mkod int not null Primary Key, --PK stunu zaten, not null yazmaya gerek yok
Mad varchar(50) not null,
msoyad varchar(50),
madres varchar(255),
mtel varchar(11),
mail varchar(100))

create table arac(
aracno int Primary Key, --PK stunu zaten, not null yazmaya gerek yok
model int not null,
marka varchar (50),
plaka varchar(15),
fiyat int,
constraint chkfiyat CHECK (fiyat>=0 AND fiyat<=100000),
tarih smalldatetime,
constraint chkmodel CHECK (model BETWEEN 1950 AND 2023)) 

create table kiralama(
mkod int not null,
aracno int not null,
tarih smalldatetime,
constraint fk_mkod FOREIGN KEY (mkod) REFERENCES musteri (mkod),
constraint fk_aracno FOREIGN KEY (aracno) REFERENCES arac(aracno),
constraint pk_key PRIMARY KEY (mkod,aracno))

/* referans tabloda satr silindiinde dier tablolardan da silinmesi veya refereans 
tabloda veriler gncellendiinde dier tablolarda da gncellenmesi iin:
ON DELETE CASCADE, ON UPDATE CASCADE */

--RNEK 13:

create table ...
..
..
constraint fk_mkod FOREIGN KEY (mkod) REFERENCES musteri (mkod)
ON UPDATE CASCADE ON DELETE CASCADE,
constraint fk_aracno FOREIGN KEY (aracno) REFERENCES arac(aracno),
ON UPDATE CASCADE ON DELETE CASCADE,
constraint pk_key PRIMARY KEY (mkod,aracno))

::--::--:: ALTER ile veritaban nesnelerinin zelliklerini deitirme ::--::--::
- Tabloya sonradan stun eklemek:

Alter table tabload ADD stunad zellik

--RNEK 14:

ALTER TABLE kiralama ADD testtarihi smalldatetime not null

-- Tabloda istenen stnu silmek iin:
ALTER TABLE tabload DROP COLUMN stunad

--RNEK 15:
alter table kiralama DROP COLUMN testtarihi

-- Tabloda stun zelliklerini deitirmek iin:
ALTER TABLE tabload ALTER COLUMN stunad zellikleri

--RNEK 16:
ALTER TABLE arac ALTER COLUMN plaka nvarchar(20)

--RNEK 17:
alter table musteri add myasi int

alter table musteri add check (myasi>0)

--RNEK 18:
alter table arac drop chkfiyat

alter table arac alter column fiyat float 

alter table arac add constraint chkfiyat CHECK (fiyat>=0 AND fiyat<=100000)


::--::--:: DROP ile DB veya tablo silme ::--::--::

Alter drop: db nesnelerinin zelliklerini silmek iin...
drop : db nesnesi (tablolar veya db) silmek iin...
Truncate - en garantili kayt silme iin
Delete

--RNEK 19:
drop table gecici

--RNEK 20:
drop database xyz   --xyz isimli db'yi siler

::--::--::--:: DML (DATA manuplation lang. / Veri ileme dili)  ::--::--::--::
Select - insert - update - delete

::--::--:: SELECT ile listeleme ilemleri ::--::--::

select stunad veya * from tabload where koul

--RNEK 21:
select * from personel
--NOT : Select rneklerinin devam iin RNEK 36 ve sonrasna baknz.

::--::--:: INSERT ile veri girii ::--::--::
INSERT INTO tabload VALUES (deer1,deer2,deer3....) 

INSERT INTO tabload(stun1,stun3,stunx..) VALUES (deer1,deer3,deerx...)

--RNEK 22:
create table personel(
pers_id int not null,
ad varchar(25),
soyad varchar(50),
sehir varchar(20),
mail varchar(100),
maas int check (maas>0))

insert into personel values (1,'ali','can','van','ali@can.com',25000)

--RNEK 23:
insert into personel(pers_id,ad,mail) values (3,'ahmet','ahmet@gamil.com')

select * from personel

--RNEK 24: herkes istedii bir stun NULL olacak ekilde kendi bilgilerini girsin.

insert into personel (pers_id, ad, soyad, mail, maas) 
VALUES (2,'Mehmet','Baaran','mehmet.basaran@mail.com', 50000)

insert into personel(pers_id,ad,soyad,mail)values(4,'utku','bolat','utkubolat@outlook.com')

insert into personel(pers_id,ad,mail,maas) values (4,'ibrahim','ibrahim@bir.com',100000)

::--::--:: UPDATE ile veri gncelleme ::--::--::
UPDATE tabload set stun1=deer1, stun2=deer2, stunx=deerx... where koul

--RNEK 25:
select * from personel

update personel set sehir='Bingl' where pers_id=3

--RNEK 26:
update personel set ad='Hakk',soyad='Bulut' where maas>50000


--RNEK 27:
update personel set maas=99999 where maas is null

--RNEK 28:  sirket@mail.com 
update personel set mail='sirket@mail.com'  where pers_id>4 OR not mail like '%@%'
veya
update personel set mail='sirket@mail.com'  where pers_id>4 OR mail not like '%@%'

--RNEK 29: 
update personel set sehir='Afyonkarahisar' where (maas>10000 and maas<50000) or soyad like '%n'
veya
update personel set sehir='Afyonkarahisar' where soyad like '%n' or maas between 9999 and 49999 
--between snrlar dahil ediyor

::--::--:: DELETE ve TRUNCATE ile veri silme ilemi ::--::--::
DELETE from tabload where koul

--RNEK 30:
delete from personel where ad  like 'c%'
select * from personel

--RNEK 31:
delete from personel  --personel tablosundaki tm veriler silinir

--RNEK 32:
truncate table personel  --personel tablosundaki tm veriler silinir 


::--::--::--:: DCL (DATA control lang. / Veri kontrol dili)  ::--::--::--::

                       REVOKE - GRANT - DENY
GRANT: kullancnn kayt yapmasna ve SQL altrmasna izin verir.

DENY: kullancy kstlar

REVOKE: izin ve kstlamalar kaldrr.


-- Grant {ALL veya izinler} ON {izin alan} TO {kullanclar}
 --- ON ifadesi tablo iin kullanlr
 ---- veritban dzeyinde ilem yapmak iin TO ifadesi yeterli


veritaban iin: create database, create table, backup database, create view
tablo iin: select, update, insert, delete
yordam iin: execute

--RNEK 33:
 grant select,update ON musteri TO aban
 
 grant ALL ON kiralama TO rabia,yavuz
 
 grant create database TO mehmet,emin

 --RNEK 34:
 deny create table TO mustafa,ali,ahmet,oya

 /*Bu komut, belirtilen kullanclara, yeni bir tablo oluturma izni vermeme amacn tar. 
 Bu kullanclar artk CREATE TABLE komutunu kullanarak yeni tablolar oluturamayacaklardr.*/
 
 --RNEK 35:
 revoke update On musteri from fatih
 /*Bu komut, "musteri" tablosu zerindeki "fatih" kullancsnn UPDATE iznini geri eker. 
 Artk "fatih" bu tablo zerinde gncelleme ilemi gerekletiremeyecektir.*/
 
 revoke ALL from selman,furkan,betl,meryem


::--::--:: Server Seviyesi Roller ::--::--::

Bulkadmin: Bulk Insert yetkisine sahip olurlar. Baka bir veri kaynandan 
veya EXCEL den veri ekme ilemleri iin kullanlr.

DBcreator: Veritaban Create, Alter, Drop, veya veritaban restore edebilir. 

Diskadmin: bu yetkiye sahip olanlar disk dosyalarn yntebilir.

Processadmin: tm processleri ynetebilir, grebilir veya KILL komutuyla processleri 
sonlandrabilir.

Public: default yetkili kullanc. SQL e baalanabilir,baka bir ilem yapamaz.

securityadmin: kullanc yetkilendirme ilemleri yapabilir. Grant, deny, revoke...
ifreleri sfrlayabilir..

serveradmin: sunucu genelinde yaplandrma yapabilir, sunucuyu deitirebilir, kapatabilir

setupadmin: stored procedure ilemleri, linked server ekleyebilir, kaldrabilir.

sysadmin: En yetkin rol. database yneticileri dndakilere verilmemeli.


::--::--::--:: veritaban Seviyesi Roller ::--::--::--::

db_owner: veritaban dzeyinde en yetkin rol.

db_securityadmin: baz zel roller iin yetkilendirme yapabilir, rol yeliini deitirebilir.

db_accessadmin: win oturum ama, sql server ama ilemleri iin veritabanna eriim ekleyebilir

db_backupoperator: bu role sahip olanlar db yi yedekleyebilir.

db_ddladmin: ddl komutlarn altraiblir.

db_datawriter: tablolara veri girii yapabilir

db_datareader: veritabanndaki verileri okuyabilir



::--::--:: SELECT ile listeleme ilemleri ::--::--::
rnekler genel olarak NORTWIND veritaban zerinde uygulanmtr

--RNEK 36:
select *  from customers

--RNEK 37:
select contactname,city from customers

--RNEK 38:
select * from customers  where customerID LIKE '%v'

--RNEK 39:
select employeeID, shipaddress from orders  where employeeId>7

--RNEK 40:
select orderID,shipregion,shipname from orders where orderID>10300 and orderID<10400

--RNEK 41:
select * from orders where shipcountry='brazil'

veya

select * from orders where shipcountry like 'Brazil'

veya 

select * from orders where shipcountry In ('Brazil')

--RNEK 42:
select ShipCity from orders where ShipCountry not like 'taly'

veya

select ShipCity from orders where not ShipCountry like 'taly'

veya

select ShipCity from orders where shipcountry not in ('italy')

veya

select ShipCity from orders where  not shipcountry in ('italy')

veya

select shipcity from orders where ShipCountry!= 'taly'

veya

select shipcity from orders where ShipCountry<>'taly'

--RNEK 43:
select tc from Kargo where gon_sube='izmir' or gon_sube='trabzon'

veya

select tc from kargo where gon_sube IN  ('izmir','trabzon')

--RNEK 44:
select customerId, shipname from orders where customerId like '_A%' or shipname like '%en%'

--RNEK 45:
select gon_ad,gon_soyad from kargo where ucret<80 or gon_ad is NULL

--RNEK 46:   ad  harfli ikinci harf L VEYA soyad G ile bitenler
select * from kargo where gon_ad like '_l_' or gon_soyad like '%g'

--RNEK 47:
select tc,ucret from kargo where tc like '6%5' 

--RNEK 48:
select shipcity,orderID,shipvia from orders
where shipcity='lyon' or shipcity='kln'

veya

select shipcity,orderId,ShipVia from orders
where shipcity IN ('lyon','kln')


--RNEK 49:
select shipname,freight from orders where shipname like 'f%b' or (freight>=5 and freight<=55)

veya

select * from orders where Shipname= '[f-b]' or freight between 5 and  55 


--RNEK 50:
select * from customers where city LIKE 'London'
veya
SELECT * FROM Customers WHERE city='London'

--RNEK 51:
select customers.customerID,orders.orderID from customers,orders

--RNEK 52:
select * from customers where city='Madrid' OR region is NULL

--RNEK 53:
select * from customers where customerID LIKE 'FR%' 
AND country IN ('Italy','Germany')

--RNEK 54:
select * from customers where customerId LIKE 'N_R%' 

 
::--::--::--:: distinct: tekrarl satrlar nlemek ::--::--::--::

--RNEK 55:
select distinct customerID from orders 

--RNEK 56:
select distinct shipcountry from orders where shipaddress like '%j%'


::--::--::--:: order by (ASC - DESC)  ::--::--::--::
--ASC kullanm
select * from tabload where koul order by referans_stun ASC -- artan (default)

veya

select * from tabload where koul order by referans_stun -- artan

--DESC kullanm
select * from tabload where koul order by ref_stun DESC -- azalan


--RNEK 57:
select shipaddress from orders order by shipaddress ASC 

veya

select shipaddress from orders order by shipaddress

veya

select shipaddress from orders order by 1


--RNEK 58:
select * from orders order by shipaddress DESC

veya

select * from orders order by 10 DESC


--RNEK 59:
select shipcountry,shipcity,shipvia from orders  order by shipcountry desc,shipcity asc

veya

select shipcountry,shipcity,shipvia from orders  order by 1 desc,2

--RNEK 60:
select shipcountry,shipcity,shipvia from orders order by 1 desc,2,3


::--::--::--:: stunlar iin takma isim kullanma ::--::--::--::

--RNEK 61:
select shipcountry AS 'lke' from orders

veya

select shipcountry 'lke' from orders

veya

select shipcountry "lke" from orders

--RNEK 62:
select mad "AD", myasi+5 "YEN YA",mail from musteri


--RNEK 63:
select shipcountry+'***'+shipcity 'adres' from orders

--RNEK 64:
select employeeID " NO",employeeID+employeeID*0.2 "ZAMLI  NO" from orders

--RNEK 65:
select 3+5 
select 3*5 as 'arpm'

--RNEK 66:
select mad 'AD', msoyad "SOYAD",(myasi/2)+3 "YARIM" from musteri

--RNEK 67:
select orderID,shipname,customerID from  orders
where freight>=50 and shipcountry IN ('spain','italy') or shipname LIKE '%o'
order by customerID

veya

select orderID,shipname,customerID from  orders
where freight>=50 and (shipcountry='spain' or shipcountry='italy') or shipname LIKE '%o'
order by 3

--RNEK 68:
select orderID 'sipari no',shipname 'kargo',customerID 'mteri no',orderID*5 'yeni' from  orders
where freight>=50 and shipcountry IN ('spain','italy') or shipname LIKE '%o'
order by customerID


--RNEK 69:
select * from musteri 
where myasi>=23 AND myasi<=28 AND madres='Ar' AND mkod>2 order by msoyad --msoyad Artan


--RNEK 70:
select plaka,madres from musteri where madres NOT IN ('Ar') order by plaka DESC

veya

select plaka,madres from musteri where madres!='Ar' order by 1 DESC  

--RNEKLER 71:
create table urunler2(
urun_no int identity(1,1) not null,
urun_adi varchar(100),
urun_fiyati float,
constraint chkfiyatt CHECK (urun_fiyati>=0 AND urun_fiyati<=1000),
urun_adedi int,
constraint chkadet CHECK (urun_adedi>=0 AND urun_adedi<=100),
islem_tarihi smalldatetime,
sevk_adresi varchar(50))

insert into urunler2 values ('Sala',3.25,100,'07.01.2019','zmir')
insert into urunler2 values ('Pirin',5.75,100,'06.02.2019','zmir')
insert into urunler2 values ('Bulgur',3.30,90,'05.03.2019','Afyon')
insert into urunler2 values ('Zeytin Ya',24.75,85,'04.04.2019','Konya')
insert into urunler2 values ('Ayiek Ya',17.25,99,'03.05.2019','Aksaray')
insert into urunler2 values ('Makarna',1.77,98,'02.06.2019','Hakkari')
insert into urunler2 values ('ehriye',1.22,100,'01.11.2019','Bursa')

select urun_fiyati+(urun_fiyati*0.25) AS "Yeni Fiyat" from urunler2

--RNEK 72: substring
select SUBSTRING (urun_adi,2,3) AS '3 Harf' from urunler2

--RNEK 73: 
select substring(shipname,3,5) AS 'KISALTMA' from orders  --3.karakterden itibaren 5 karakter al

--RNEK 74:
select substring(shipcity,1,1)+'.'+shipcountry "AD SOYAD" from orders

--RNEK 75:  RIGHT / LEFT
select RIGHT(customerID,4),customerID from orders

--RNEK 76:
select LEFT (sevk_adresi,1)+'.'+urun_adi AS 'Ad Soyad' from urunler2

--RNEK 77: UPPER / LOWER
select lower(customerID), UPPER(shipaddress) from orders

--RNEK 78: LEN
select urun_adi,LEN(urun_adi) As "uzunluk1",
urun_adedi,LEN(urun_adedi) as "uzunluk2" from urunler2

--RNEK 79: REPLACE
select shipcountry,REPLACE(shipcountry,'USA','zmir Gltepe') 'Yeni sim' from orders

--RNEK 80: REVERSE
select REVERSE(shipcountry) as 'ters isim' from orders

--RNEK 81: ABS
select ABS(-0.45) as mutlak 

--RNEK 82: ROUND
select freight,ROUND(freight,1) as "yuvarlanm" from orders

--RNEK 83: POWER
select POWER (2,3) as "kp alma"

--RNEK 84: SQRT
select SQRT(64)

--RNEK 85: SUM
select SUM(freight) 'Toplam' from orders where shipcountry<>'Germany'

--RNEK 86:
select SUM(urun_fiyati) "Toplam" from urunler2 
where islem_tarihi>='3.3.2019'

--RNEK 87:
select SUM(urun_adedi) "Toplam rn" from urunler2 
where urun_no>2 AND urun_no<=7 AND sevk_adresi like '%a' OR sevk_adresi like '%i'

--RNEK 88: AVG
select ROUND(AVG(urun_fiyati),2) as "ortalama fiyat" from urunler2

--RNEK 89:  MAX / MIN
select MAX(urun_Adedi),MIN(urun_fiyati) from urunler2

--RNEK 90: 
select MAX(orderdate) from orders

--RNEK 91: COUNT
select COUNT(urun_adi) as "eit says" from urunler2

--RNEK 92:
select COUNT(distinct shipcity) from orders

--RNEK 93: RTRIM / LTRIM - Boluklar kaldrmak
select RTRIM(shippostalcode) from orders

--RNEK 94: CEILING (yukar yuvarlama) - FLOOR (aa yuvarlama)
select freight,CEILING(freight),FLOOR(freight) from orders

--RNEK 95: CURRENT_TIMESTAMP (gncel tarih ve saat bilgisi)
select CURRENT_TIMESTAMP

--RNEK 96: GETDATE  (gncel tarih ve saat bilgisi)
select GETDATE()

--RNEKLER 97: DATEPART ile tarih-saat bilgisinden istenen ksm alma
select datepart(year,getdate())  --yl bilgisi aldk
select datepart(month,getdate())  -- ay bilgisi 
select datepart(day,getdate())     --gn bilgisi 
select datepart(week,getdate())     --hafta bilgisi 

--RNEKLER 98: DATEPART
select datepart(day,'2024-01-03')     --gn bilgisi (3.gn)
select datepart(quarter,'2024-01-03')     --yln eyrei bilgisi 

--RNEKLER 99: DATENAME
select datename(month,getdate())  --ay ismini aldk/rendik
select datename(weekday,getdate())  --gn ismini aldk
select datename(month,'2023-12-03')   --ay ismini aldk/rendik
select datepart(minute,getdate())		--kanc dk olduumuzu listeledik
select datename(minute,getdate())		--kanc dk olduumuzu listeledik

--RNEK 100: 
Tablo ismi arasnda boluk olduu iin keli paranteze alarak listeleme yapyoruz

select * from [Order Details]
